## 数组操作之获取最值

```java
int[] arr = {4,1,3,9};
9
int a = arr[0];
for (int i = 1; i < arr.length; i++) {
    // 4 < 9
   if (a < arr[i]) {
       // a = 9;
        a = arr[i];
   } 
}

a

```

* 最值
	* 最小值和最大值
* 编程思维: 数组获取最大值
	* 定义一个变量max, 保存最大值, 先拿数组中的第一个元素作为参照物
	* for循环遍历数组中的其他元素, 让其他元素和max依次比较
        * 如果元素比max大, 则说明该元素应作为最大值, 所以将该元素存入max
    * 整个for循环遍历比较结束, max保存的就是最大值
* 编程思维: 数组获取最小值
	* 定义一个变量min, 保存最小值, 先拿数组中的第一个元素作为参照物
	* for循环遍历数组中的其他元素, 让其他元素和min依次比较
        * 如果元素比min小, 则说明该元素应作为最小值, 所以将该元素存入min
    * 整个for循环遍历比较结束, min保存的就是最小值
## 二维数组的概述和基本使用

* 二维数组:
	* 概念: 二维数组是元素为一维数组的数组
	* 定义格式:
	    * 格式1: `数据类型[][] 数组名;` (推荐)
	    * 格式2: `数据类型 数组名[][];`
	    * 格式3: `数据类型[] 数组名[];`
	* 初始化格式
	    1. 动态初始化: `数据类型[][] 数组名 = new 数据类型[m][n];`
	        * `m`: 二维数组中一维数组的个数(二维数组的长度)
	        * `n`: 一位数组中的元素个数(二维数组中一维数组的长度)
	    2. 静态初始化: 
	        * 标准格式: `数据类型[][] 数组名 = new 数据类型[][]{{...}, {...}, {...}, ...};`
	        * 简化格式: `数据类型[][] 数组名 = {{...}, {...}, {...}, ...};`
	    * 两种初始化的区别:
	        * 动态初始化, 二维数组中的一维数组的长度是固定的, 因为n已经确定
	        * 静态初始化, 二维数组中的一位数组长度可以是不同的  {{1,2}, {3,4,5,6,7}}
	    * 注意:
		    * `int[][] arr = new int[3][];`不给一维数组长度是正确的, 相当于`{null, null, null}`
			    * 含义: 创建了一个长度为3的二维数组, 而不创建内部的一维数组. 而动态初始化是需要给元素默认值的, 二维数组中的一维数组是引用类型, 所以是默认值null. 即创建完的数组为`[null, null, null]`
			    * 如果不给二维数组长度则是错误的, 因为虚拟机无法知道要如何创建该数组
	* 获取二维数组中某个一维数组的某个元素值: 
		* `arr[二维数组索引][一维数组索引]`
* 初始化示例:

```java
// 二维数组的动态初始化
int[][] arr = new int[2][3];

// 二维数组的静态初始化
int[][] arr = {{1, 2}, {3, 4}, {5, 6, 7, 8}};## 今日扩展

* 能否创建长度为0的数组? 该数组能否存储元素?
	* 可以创建长度为0的数组:
		* 动态初始化: `int[] arr = new int[0];`
		* 静态初始化: `int[] arr = {};`
	* 长度为0的数组不能存储元素
	* 注意:
		* 不能创建长度为负数的数组, 会抛出异常`NegativeArraySizeException`
		* 长度为0的数组依然是一个对象, 有地址值. 与null不同


* 如何能够在一个数组中添加不重复的, 随机的数值?
  * 先生成一个随机数
  * 然后遍历当前数组, 查看刚才生成的随机数与数组中的每个元素是否重复
    * 重复则继续生成
    * 不重复则存入数组

```java
int[] arr = new int[5];

Random r = new Random();

// 遍历数组, 为数组每个元素生成不重复的随机数
for (int i = 0; i < arr.length; i++) {
	// 为数组每个索引生成不重复的随机数
    while (true) {
        // 生成一个随机数
        int num = r.nextInt(10);
        // 定义一个布尔变量, 用于保存数组中是否有与该随机数相同的值
        boolean isSame = false;
        // 判断该随机数是否在数组中有相同的值
        for (int j = 0; j < arr.length; j++) {
            if (arr[j] == num) {
                // 有相同的元素
                isSame = true;
                // 结束for循环, 有一个相同就够了, 后边的不用比较了
                break;
            }
        }
        // for循环结束后判断布尔变量
        if (!isSame) {
            // 没有相同的, 则添加该随机数到数组指定索引位置
            arr[i] = num;
            // 结束while循环, 让最外层for继续, 以便给下一个数组元素生成随机数
            break;
        }
        // 如果有相同的, 则while循环继续, 生成新的随机数并判断是否有重复的 
    }## 今日总结

* Random类
	* 作用: 生成一个随机数
	* 步骤:
		* 导包: `import java.util.Random;`
		* 创建对象: `Random r = new Random();`
		* 生成随机数: `int n = r.nextInt(10);`, 获取0到9的随机数(0到10, 包含0不包含10)
* 数组
	* 一维数组
		* 数组概念: 存储同一种数据类型的多个元素的容器
		* 定义:
			* `数据类型[] 数组名;`, **推荐**
			* `数据类型 数组名[];`
		* 初始化
			* 动态初始化: 我们给定数组长度, 由系统给定元素的初始值
				* 格式: `数据类型[] 数组名 = new 数据类型[数组长度];`
				* 示例: `int[] arr = new int[3];`
			* 静态初始化: 我们给定元素的初始值, 由系统给定数组长度
				* 格式: 
					* 普通格式: `数据类型[] 数组名 = new 数据类型[]{元素1, 元素2, ...};`
						* 示例: `int[] arr = new int[]{1, 2, 3};`
					* 简化格式: `数据类型[] 数组名 = {元素1, 元素2, ...};`
						* 示例: `int[] arr = {1,2,3};`
		* 数组的长度
			* 什么是长度? 数组中元素的个数
			* 数组名.length: length是属性, 获取数组的长度
		* 数组中元素的默认值
			* int: `0`
			* float, double: `0.0`
			* char: `'\u0000'`
			* boolean: `false`
			* 引用类型: `null`
		* 数组元素的访问
			* 格式: `数组名[索引]`
			* 数组的索引: 元素的编号, 从0开始
		* 数组的遍历
			* 什么叫做遍历: 依次获取数组中的所有元素
			* 如何遍历? for循环实现
	* 二维数组
		* 什么是二维数组: 元素为一维数组的数组
		* 定义
			* `数据类型[][] 数组名;`, **推荐**
			* `数据类型[] 数组名[];`
			* `数据类型 数组名[][];`
		* 初始化
			* 动态初始化
				* 格式: `数据类型[][] 数组名 = new 数据类型[二维数组的长度][一维数组的长度];`
					* 示例: `int[][] arr = new int[2][3];`
			* 静态初始化
				* 普通格式: `数据类型[][] 数组名 = new 数据类型[][]{{元素1, 元素2,...}, {元素1, 元素2,...}, ...};`
					* 示例: `int[][] arr = new int[][]{{1, 2}, {3, 4, 5}};`
				* 简化格式: `数据类型[][] 数组名 = {{元素1, 元素2,...}, {元素1, 元素2,...}, ...};`
					* 示例: `int[][] arr = {{1, 2}, {3, 4, 5}};`
		* 访问元素: 
			* 格式: `数组名[二维数组的索引][一维数组的索引]`
		* 二维数组的遍历: 嵌套for循环
	* 数组操作常见的2个异常:
		* `ArrayIndexOutOfBoundsException`: 数组索引越界异常
			* 发生原因: 使用了不存在的索引
			* 如何避免: 检查索引, 防止越界
		* `NullPointerException`: 空指针异常
			* 发生原因: 引用类型的变量保存的值为null, 然后访问了数组元素或是调用了方法或属性
			* 如何避免: `if (引用类型变量 != null) {操作}`
	* 数组获取最值(熟练代码书写)
	* 两个数组变量指向同一个数组的操作(会画图, 会分析)
* Java内存
	* 内存分区
		* 栈: 存放局部变量
			* 垃圾会立即回收
		* 堆: 存放new出来的对象
			* 垃圾要在垃圾回收器空闲时回收
		* 方法区
		* 本地方法区
		* 寄存器
	* 数组的内存分配
		* `int[] arr`: 在栈中开辟内存空间
		* `new int[3];`: 在堆中开辟内存空间, 并初始化元素的默认值
		* `=`: 将堆内存中数组的地址值赋值给arr变量


```java
// 一维数组的遍历
int[] arr = {1, 2, 3};
for (int i = 0; i < arr.length; i++) {
	syso(arr[i]);
}

// 二维数组的遍历
int[][] arr2 = {{1, 2}, {3, 4, 5}};
for (int i = 0; i < arr2.length; i++) {
	for (int j = 0; j < arr2[i].length; j++) {
		syso(arr2[i][j]);
	}
}
for (int i = 0; i < arr2.length; i++) {
	int[] subArr = arr2[i];
	for (int j = 0; j < subArr.length; j++) {
		syso(subArr[j]);
	}
}
```

* 编程思维: 数组获取最大值
	* 定义一个变量max, 保存最大值, 先拿数组中的第一个元素作为参照物
	* for循环遍历数组中的其他元素, 让其他元素和max依次比较
        * 如果元素比max大, 则说明该元素应作为最大值, 所以将该元素存入max
    * 整个for循环遍历比较结束, max保存的就是最大值

```java
// 用数组第一个元素作为临时最大值
int max = arr[0];
// 遍历数组, 获取其他元素与最大值比较
for (int i = 1; i < arr.length; i++) {
	// 获取数组中的一个元素, 与max比较
	if (max < arr[i]) {
		// 说明max比当前元素小, 应该将当前元素存入max
		max = arr[i];
	}
}
// 循环结束后, max就是最大值
System.out.println("数组中的最大值为:" + max);
```


* 编程思维: 数组获取最小值
	* 定义一个变量min, 保存最小值, 先拿数组中的第一个元素作为参照物
	* for循环遍历数组中的其他元素, 让其他元素和min依次比较
        * 如果元素比min小, 则说明该元素应作为最小值, 所以将该元素存入min
    * 整个for循环遍历比较结束, min保存的就是最小值

```java
// 用数组第一个元素作为临时最小值
int min = arr[0];
// 遍历数组, 获取其他元素与最小值比较
for (int i = 1; i < arr.length; i++) {
	// 获取数组中的一个元素, 与max比较
	if (min > arr[i]) {
		// 说明min比当前元素大, 应该将当前元素存入min
		min = arr[i];
	}
}
// 循环结束后, min就是最小值
System.out.println("数组中的最小值为:" + min);
```