# day07 面向对象-基础
* 2个概念的区别
  1. 面向过程: 强调的是过程, 关注做事的步骤, 重点是怎么做
  2. 面向对象: 强调是的对象, 关注做事的角色, 重点是让谁来做
* 面向对象的3个特点:
  1. 更符合人类思考习惯. (懒)
  2. 将复杂事情简单化.
  3. 从执行者转变为指挥者.


## 类和对象的概述

* 类: 描述同一类 **事物** 的 **属性** 和 **行为**
	- 属性: 事物的描述信息 (事物有什么)
	- 行为: 事物能做什么
* 对象: 一类事物的具体的一个体现


* 个体学生和全体学生举例: 
    * 对象 -> 吴同学, 赵同学都是个体
    * 类   -> 学生


## 面向对象概述

* 面向过程: Procedure Oriented Programming. 
	* 我们要面向具体每一个步骤和过程, 完成每个步骤, 然后由这些方法相互调用, 完成需求.
	* 面向过程的编程语言: C
* 面向对象: 英文OOP, Object Oriented Programming   
	* 产生这个概念的原因: 当需求和功能增多时, 我们想通过一种方式将相似的功能归类到一起, 减少重复的代码编写, 提高代码的复用性
* 2者关系: 
	* 面向对象是基于面向过程的
* 2个概念的区别
  1. 面向过程: 强调的是过程, 关注做事的步骤, 重点是怎么做
  2. 面向对象: 强调是的对象, 关注做事的角色, 重点是让谁来做
* 面向对象的3个特点:
  1. 更符合人类思考习惯. (懒)
  2. 将复杂事情简单化.
  3. 从执行者转变为指挥者.


## 类和对象的概述

* 类: 描述同一类 **事物** 的 **属性** 和 **行为**
	- 属性: 事物的描述信息 (事物有什么)
	- 行为: 事物能做什么
* 对象: 一类事物的具体的一个体现


* 个体学生和全体学生举例: 
    * 对象 -> 吴同学, 赵同学都是个体
    * 类   -> 学生
    * ## 今日总结

* 面向对象
	* 面向过程:
		* 向具体每一个步骤和过程, 完成每个步骤, 然后由这些方法相互调用, 完成需求
	* 面向对象
		* 当需求和功能增多时, 我们想通过一种方式将相似的功能归类到一起, 减少重复的代码编写, 提高代码的复用性
	* 两者区别:
		* 面向过程, 强调的是过程, 关注的是做事的步骤
		* 面向对象, 强调的是对象, 关注做事的角色
	* 面向对象的3个特点
		* 更符合人类思考习惯
		* 将复杂的事情简单化
		* 从执行者变为指挥者
	* 类和对象
		* 类: 描述同一类事物的属性和行为
			* 属性: 事物有什么
			* 行为: 事物能做什么
		* 对象: 一类事物的具体体现
	* 事物和类的转换
		* 事物: 类
		* 事物的属性: 类的成员变量
		* 事物的行为: 类的成员方法
	* 类的定义
		* 定义类: 
			* `public class 类名 {}`
		* 定义类中的成员变量: 
			* `权限修饰符 数据类型 变量名;`
			* 示例: `private String name;`
		* 定义类中的构造方法: 
			* `权限修饰符 方法名(参数列表) {方法体}`
			* 示例: 
				* 空参: `public Student() {}`
				* 有参: `public Student(String name) { this.name = name; }`
		* 定义类中的get/set方法(getter, setter): 
			* `权限修饰符 返回值类型 方法名() {方法体}`
			* 示例: 
				* set方法: `public void setName(String name) { this.name = name; }`
				* get方法: `public String getName() { return name; }`
		* 定义其他成员方法
			* 吃饭: `public boolean eat() { syso("吃饭"); }`
	* 如何使用一个类: 创建对象来使用
		* 格式: `类名 对象名 = new 类名();`, `类名()`实际上是构造方法
			* 如: `Student student = new Student();`
		* 调用成员变量: 
			* 获取值: 
				* `数据类型 变量名 = 对象名.成员变量名;`
				* 如: `int age = student.age;`
			* 赋值: 
				* `对象名.成员变量名 = 值;`
				* 如: `student.age = 20;`
		* 调用成员方法: 
			* `对象名.成员方法名();`
			* 如: `student.study();`
	* 构造方法
		* 作用: 
			* 初始化成员变量
		* 调用时机: 创建对象时
		* 格式: `权限修饰符 类名(参数列表) {方法体}`
		* 注意:
			1. 构造方法没有返回值类型, 没有返回值(但可以理解为返回了该类的对象)
			2. 构造方法如果没有显式的定义, 默认会有一个无参的构造方法
			3. 如果已经显式定义了构造方法, 则没有默认的无参构造方法
		* 构造方法也可以重载
			* 无参构造和有参构造就是重载
	* private关键字:
		* 作用: 权限修饰符, 可以修饰类, 成员变量, 方法. 被private修饰的只能在本类访问到
		* 一般成员变量要用private修饰, 并配合public的set/get方法使用
	* this关键字:
		* 作用: 处理局部变量和成员变量重名的问题
		* this是什么: 所在类的对象的引用
	* 成员变量和局部变量的区别
		* 定义位置不同
			* 成员变量: 类中方法外
			* 局部变量: 方法内或方法声明上(方法的形参)
		* 在内存中的区域不同
			* 成员变量: 堆内存中
			* 局部变量: 栈内存中
		* 生命周期不同:
			* 成员变量: 随对象的创建而创建, 随对象的销毁而销毁
			* 局部变量: 随方法的调用而创建, 随方法的调用完毕而销毁
		* 默认值不同
			* 成员变量: 有默认初始值
			* 局部变量: 没有默认的初始值, 必须先赋值才使用
		* 作用域不同
			* 成员变量: 所在类
			* 局部变量: 所在方法
	* 面向对象的三大特征:
		* 封装
			* 封装的原则: 
				* 将不需要对外提供的内容私有
				* 将所有属性私有, 并提供public的set/get方法
			* 封装的好处:
				* 提高代码的安全性
				* 提高代码的复用性
			* 类是封装, 方法也是封装
		* 继承
		* 多态

```java
// JavaBean
// 定义一个类的示例
public class Student {

	// 成员变量
	private String name;

	// 无参构造方法
	public Student() {}  

	// 有参构造
	public Student(String name) {
		this.name = name;
	}

	// get/set方法
	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}

	// 其他成员方法
	public boolean eat() {
		System.out.println("吃饭");
		return false;
	}
}
```

定义的类:

* JavaBean(如学生, 手机类): 用于描述和封装数据, 便于数据的传递
	* 例如要传递学生的多种信息到某个方法中, 这样很麻烦
		* saveStudent(name, age, gender, address, email, phoneNumber, className);
	* 如果将属于学生的信息都封装到学生对象内, 然后传递学生对象, 这样代码会非常简洁. 类似于将信息打包装起来
		* Student s = new Student(name, age, gender, address, email, phoneNumber, className);
		* saveStudent(s);
* Random/Scanner: 用于实现某种特定功能
			