|运算符|结合性|
|------|------|
|[ ] . ( ) | 从左向右 |
| ! ~ ++ --  |从右向左|
|* / % | 从左向右 |
| + - | 从左向右 |
| << >> >>> | 从左向右 |
| < <= > >= instanceof | 从左向右 |
| == != | 从左向右 |
| & | 从左向右 |
| ^　| 从左向右 |
|\| | 从左向右 |
| && | 从左向右 |
| \|\| | 从左向右 |
| ? : | 从右向左 |
| = += -= *= /= %= &= \|= ^= <<= >>= >>= | 从右向左 
* 取余, 取模
	* 取余: remainder
	* 取模: modulus
	* 两者区别: `x 操作 y`, 当x和y的正负号一样的时候，取余和取模结果是等同的; 当x和y的符号不同时，取余结果的符号和x的一致，而取模和y一致
	* Java中`%`只表示取余, 即结果的符号和x一致, 与y的符号无关
	* Java中没有直接的取模运算符, 有些书中将取余等同于取模
* 取余%操作的用途
	* 判断是否是奇数偶数
	* 判断是否能被某个数整除
	* 获取一个数的个位, 十位, 百位...
	* * 运算符
	* 算术运算符
		* `+`: 加
		* `-`: 减
		* `*`: 乘
		* `/`: 除
			* 整数相除结果仍然为整数
			* 如果想要得到小数, 需要有小数参与运算
		* `%`: 取余
		* `++`: 自增
		* `--`: 自减
		* 自增和自减的注意事项
			* `i++`和`++i`的区别:
				* 单独使用时, 结果一样
				* 参与运算时
					* `i++`: 先使用i的值作为i++表达式的值, 然后i自增
					* `++i`: i先自增, 然后使用自增后的值作为++i表达式的值
		* 字符参与加法运算
			* 在参与运算时, 以字符本身的值进行运算, 结果为数字
			* 直接打印字符时, 输出的仍然是字符
		* 字符串参与加法运算: 拼接字符串
	* 赋值运算符
		* `=`: 赋值
		* `+=`: 拿左边和右边的值相加, 然后赋值给左边
		* `-=`: 拿左边和右边的值相减, 然后赋值给左边
		* `*=`: 拿左边和右边的值相乘, 然后赋值给左边
		* `/=`: 拿左边和右边的值相除, 然后赋值给左边
		* `%=`: 拿左边和右边的值取余, 然后赋值给左边
		* 注意事项
			* 扩展的赋值运算符隐含了强制类型转换
			* `int i += 10;`相当于`int i = (int)(i + 10);`
	* 关系运算符
		* `==`: 相等
		* `!=`: 不等
		* `>`: 大于
		* `>=`: 大于等于
		* `<`: 小于
		* `<=`: 小于等于
		* 关系运算符的结果是boolean类型的
	* 逻辑运算符
		* 用于连接关系表达式
		* `&`: 与. 两边都为true则为true, 否则为false
		* `|`: 或. 只要有一边为true则为true, 否则false
		* `^`: 异或. 男女是真爱(两边不同为true, 两边相同为false)
		* `!`: 非. 取相反的值
		* `&&`: 短路与. 和`&`结果一样, 但如果左边能够直接确定结果, 则右边不判断
		* `||`: 短路或. 和`|`结果一样, 但如果左边能够直接确定结果, 则右边不判断
	* 三元运算符
		* 格式: `关系表达式? 结果为true的表达式 : 结果为false的表达式;`
			* 当关系表达式为true时, 返回左边的
			* 当关系表达式为false时, 返回右边的
			* 注意, 三元运算符是有返回值的, 所以必须定义一个变量接收返回值
		

![image](https://note.youdao.com/favicon.ico)
