## ArrayList元素的删除, 修改, 获取


* 成员方法:
	* 删除元素: 
	    * `boolean remove(Object o)`: 删除指定元素, 返回是否删除成功
	    * `E remove(int index)`: 删除指定索引处的元素, 返回被删除的元素
	* 修改元素
		* `E set(int index, E element)`: 将指定索引位置设置为传入的元素. 如果该索引位置已有元素, 则返回被替换的元素
	* 查询元素
		* `E get(int index)`: 获取指定索引处的元素 
	* 获取集合的长度
		* `int size()`: 获取集合中元素的个数
* 注意:
	* 3种获取长度
		1. 获取数组长度: `数组.length;`属性
		2. 获取String长度: `字符串.length();`方法
		3. 获取集合长度: `集合.size();`方法
	* 总共就这3种, 不会再多了, 不要记混!
	* ## 今日总结

* 对象数组
	* 数组中也可以存储自定义对象
	* 对象数组中存储的是对象的地址值
* 集合
	* 概念: 集合本身不是一个类, 是一些容器类的统称.
	* 特点: 长度可变
	* ArrayList类
		* 构造方法:
			* `ArrayList()`
				* `<E>`: 泛型, 作用是约束集合中元素的数据类型, 只能写引用数据类型 
				* 示例: `ArrayList<Student> array = new ArrayList<Student>();`
		* 成员方法
			* 增加: 
				* `boolean add(E e)`: 添加一个对象到集合的末尾
				* `void add(int index, E e)`: 在指定索引上添加一个元素, 如果已有元素, 则从该元素开始会向后移动
			* 删除
				* `boolean remove(Object o)`: 直接删除一个元素
				* `E remove(int index)`: 删除指定索引位置的元素, 返回被删除的元素  
			* 修改
				* `E set(int index, E e)`: 将指定索引位置的元素修改为新的元素, 返回被替换的元素
			* 查询
				* `E get(int index)`: 获取指定索引上的元素
			* 获取长度
				* `int size()`: 获取集合的长度
		* 集合的遍历:
			* for循环配合集合的size()方法和get()方法遍历
* 学生管理系统(集合版本)
	* `System.exit(0)`: 退出虚拟机, 结束程序
	* `\t`: 制表符, 相当于键盘的tab键的效果
	## 今日总结

* IO流
	* IO: In输入, Out输出, 输入输出流
	* IO的作用: 
		* 读写磁盘上的文件
		* 网络流的读写
	* 分类:
		* 按方向分:
			* 输入流
			* 输出流
		* 按照数据分
			* 字节流
			* 字符流(今天所讲): 都是文本
	* 注意IO的方向: 都是相对于我们编写的Java程序来判断
	* 路径:
		* 绝对路径: 真实路径, 以系统盘符开始的路径. `d:\\a.txt`
    	* 相对路径: 不以盘符开始的路径, 相对于某个目录(在Eclipse中是项目根目录)的路径. `a.txt`
	* 换行符
	    * `\n`: Linux系统的换行符
	    * `\r`: Mac系统的换行符
	    * `\r\n`: Windows系统的换行符
	* 相关的类
		* 基本输入输出流
			* `FileReader`: 文件字符输入流
				* 构造方法: 
					* `FileReader(String fileName)`: 使用fileName文件路径字符串创建一个FileReader对象
				* 成员方法:
					* `int read()`: 读取一个字符, 返回该字符的数值. 读到末尾返回-1
					* `int read(char[] cbuf)`: 读取字符并存入传入的字符数组, 返回读取的字符的个数. 读到末尾返回-1
					* `void close()`: 关闭流并释放资源
			* `FileWriter`: 文件字符输出流
				* 构造方法: 
					* `FileWriter(String fileName)`: 使用fileName文件路径字符串创建一个FileWriter对象
					* `FileWriter(String fileName, boolean append)`: 使用fileName文件路径字符串创建一个FileWriter对象, append为true时是追加模式, false时不追加
				* 成员方法: 
					* `void write(int ch)`: 写入一个字符到缓冲区
					* `void write(char[] cbuf)`: 将字符数组的内容写入到缓冲区
					* `void write(char[] buf, int offset, int length)`: 写入字符数组中指定索引开始的指定长度的字符到缓冲区
					* `void write(String str)`: 写入一个字符串到缓冲区
					* `void write(String str, int off, int len)`: 写一个字符串中指定索引开始的指定长度的字符串到缓冲区
					* `void flush()`: 将内存缓冲区中的数据刷新到文件中
					* `void close()`: 将内存缓冲区中的数据刷新到文件中, 关闭流并释放资源
		* 缓冲输入输出流
			* `BufferedReader`: 缓冲字符输入流
				* 构造方法: 
					* `BufferedReader(Reader in)`: 使用默认缓冲区大小创建缓冲输入流对象
				* 成员方法:
					* `int read()`: 读取一个字符, 返回该字符的数值. 读到末尾返回-1
					* `int read(char[] buf)`:读取字符并存入传入的字符数组, 返回读取的字符的个数. 读到末尾返回-1
					* `String readLine()`: 读取一行数据, 返回该行数据的字符串, 但不包含换行符
					* `void close()`: 关闭流并释放资源
			* `BufferedWriter`: 缓冲字符输出流
				* 构造方法: 
					* `BufferedWriter(FileWriter writer)`: 使用默认缓冲区大小创建缓冲输出流对象
				* 成员方法: 
					* `void write(String s)`: 写一个字符串到缓冲区
					* `void write(int ch)`: 写一个字符到缓冲区
					* `void write(char[] buf, int offset, int length)`: 写入数组中指定索引开始的指定长度的字符到缓冲区
					* `void newLine()`: 写入一个换行符, 换行符由系统确认
					* `void flush()`: 将内存缓冲区中的数据刷新到文件中
					* `void close()`: 将内存缓冲区中的数据刷新到文件中, 关闭流并释放资源
* 重点: 5种复制文件的代码, 最好全背写出来. 
	* 基本流一次读写一个字符
	* 基本流一次读写一个字符数组
	* 缓冲流一次读写一个字符
	* 缓冲流一次读写一个字符数组
	* 缓冲流一次读写一行


```java
// 1.基本流一次读写一个字符
FileReader fr = new FileReader("被复制的文件");
FileWriter fw = new FileWriter("新文件");

// 读写
int ch;
while((ch = fr.read()) != -1) {
	fw.write(ch);
}
// 释放资源
fw.close();
fr.close();



// 2.基本流一次读写一个字符数组
FileReader fr = new FileReader("数据源");
FileWriter fw = new FileWriter("目的地");

// 读写
char[] chs = new char[1024];
int len;
while((len = fr.read(chs)) != -1) {
	fw.write(chs, 0, len);
}
// 释放资源
fw.close();
fr.close();



// 3.缓冲流一次读写一个字符
BufferedReader br = new BufferedReader(new FileReader("数据源"));
BufferedWriter bw = new BufferedWriter(new FileWriter("目的地"));

// 读写
int ch;
while((ch = br.read()) != -1) {
	bw.write(ch);
}
// 释放资源
bw.close();
br.close();



// 4.缓冲流一次读写一个字符数组
BufferedReader br = new BufferedReader(new FileReader("数据源"));
BufferedWriter bw = new BufferedWriter(new FileWriter("目的地"));

// 读写
char[] chs = new char[1024];
int len;
while ((len = br.read(chs)) != -1) {
	bw.write(chs, 0, len);
}
// 释放资源
bw.close();
br.close();


// 5.缓冲流一次读写一行字符串
BufferedReader br = new BufferedReader(new FileReader("数据源"));
BufferedWriter bw = new BufferedWriter(new FileWriter("目的地"));

// 读写
String line;
while ((line = br.readLine()) != null) {
	bw.write(line);
	bw.newLine();
	bw.flush();
}
// 释放资源
bw.close();
br.close();
```

