# day08 String


## API概述及使用步骤

* API: Application Programming Interface, **应用程序编程接口**
	* 其实就是**Java提供的已经定义好的一些类和方法**, 便于我们简化开发
	* 学会查看API文档, 就相当于开始使用面向对象的思想, 找到哪个类的哪个方法来帮我们做事, 而不用考虑具体的细节
* 如果chm文件不能使用索引功能:
    1. `Win + R`打开运行
    2. 输入`regsvr32 itircl.dll`, 确认即可


## 键盘录入一个字符串数据

* 查看文档, 学习如何使用Scanner类
* `java.util.Scanner`
	* `String nextLine()`: 
	* ## String类的概述和构造方法

* String类: 表示字符串类型, 并提供了操作字符串的相关方法
	* 构造方法
		* `String(String origin)`: 使用一个字符串创建一个新的字符串对象
			* `new String("a");`
		* `String(char[] value)`: 使用char数组中的字符创建一个字符串对象
			* `char[] chs= {'a', 'b', 'c'};   String s = new String(chs);` 
		* `String(char[] value, int offset, int count)`: 使用char数组中从offset索引开始, 取count个字符来创建一个字符串对象

## String类的判断功能

* Object类: 
	* 顶级类, 所有类都继承自Object类
* 有哪些判断功能?
    * `boolean equals(Object anObject)`: 比较字符串的**内容**是否相同, 区分大小写   "hello".equals("hello")
    * `boolean equalsIgnoreCase(String anotherString)`: 比较字符串的**内容**是否相同, 不区分大小写 
    * `boolean startsWith(String prefix)`: 是否以指定的字符串开头 
    * `boolean endsWith(String suffix)`: 是否以指定的字符串结尾  
* 扩展:
	* `boolean contains(CharSequence s)`: 是否包含指定的字符串, 如"Hellojava"是否包含java, 就可以用这个方法判断  


```java
// 2个字符串对象如何比较内容是否相同?
// 创建对象
String s1 = new String("hello");  // 创建对象
String s2 = "hello";

// 调用equals()方法
boolean b = s1.equals(s2);
```
## 模拟用户登录

* 需求:
	* 用字符串定义正确的用户名和密码, 模拟已经注册
	* 用键盘录入实现登录功能
		* 键盘分别录入用户名和密码
		* 录入完毕后判断录入的用户名和密码与已经存储的用户名密码是否一样
            * 如果正确则提示登陆成功, 结束程序
            * 如果错误则提示错误, 并提示剩余次数
        * 总共有3次机会
* 5分钟练习: 模拟登录
	* 继续使用项目s1-day08, 建包com.itheima.practice_02, 建类Test
	* 定义变量保存用户名和密码
	* 创建Scanner对象
	* 在for循环中3次获取用户名和密码的输入
		* 判断用户名和密码是否匹配
			* 如果匹配, 则提示"登录成功", break
			* 如果不匹配
				* 如果不是最后一次, 则提示"登录失败!您还有x次机会"
				* 如果最后一次失败, 则只提示"登录失败"
				* (2 - i)判断次数

```java
/*
键盘录入用户名和密码
用户名和密码只有都为admin时才提示用户登录成功
否则登录失败
用户只有录入用户名和密码总共只有三次机会
 */
public class Test {

	public static void main(String[] args) {
		// 先定义存储的正确的用户名和密码
		String username = "admin";
		String password = "admin";
		
		Scanner scanner = new Scanner(System.in);
		// 循环3次机会
		for (int i = 0; i < 3; i++) {
			// 键盘录入用户名和密码
			System.out.println("请输入用户名:");
			String user = scanner.nextLine();
			System.out.println("请输入密码:");
			String pwd = scanner.nextLine();
			// 判断用户名和密码是否正确
			if (username.equals(user) && password.equals(pwd)) {
				// 密码正确
				System.out.println("登录成功");
				// 结束循环
				break;
			} else {
				// 密码错误, 提示
				if ((2-i) == 0) {
					// 没机会了
					System.out.println("错误次数过多, 请充值100元解决");
				} else {
					// 提示剩余机会
					System.out.println("用户名或密码错误, 您还有" + (2-i) + "次机会");
				}
			}
		}
	}
}
```
## String类的获取功能

* 字符串的获取功能
    * `int length()`: 获取字符串的长度   
    * `char charAt(int index)`: 获取指定索引处的字符 
    * `int indexOf(String str)`: 获取str在字符串对象中第一次出现的索引, 没有则返回-1   
    * `String substring(int beginIndex)`: 从beginIndex索引开始截取字符串, 到字符串的末尾   "helloworld"
	* `String substring(int beginIndex, int endIndex)`: 从beginIndex开始截取字符串, 到endIndex结束, 不包括endIndex
* 注意区分:
	* 数组是`length`属性
	* 字符串是`length()`方法


## 字符串的遍历

* 如何取出字符串中的每个字符? 
	* for循环遍历字符串, 到字符串的length()为止, 每次调用charAt(int index)方法获取字符
## 字符串的遍历

* 如何取出字符串中的每个字符? 
	* for循环遍历字符串, 到字符串的length()为止, 每次调用charAt(int index)方法获取字符



* 5分钟练习: 打印字符串中的每个字符
	* 继续使用项目s1-day08, 建包com.itheima.practice_03, 建类Test
	* 定义字符串变量保存一个字符串
	* 使用for循环, 从0开始, 到字符串的length()方法结束
		* 调用字符串的`charAt()`方法获取一个字符, 打印出来

```java
/*
指定任意一个字符串
打印出该字符串中每个字符
 */
public class Test {

	public static void main(String[] args) {
		// 定义字符串
		String s = "abcde";
		// for循环遍历
		for (int i = 0; i < s.length(); i++) {
			// 获取一个字符串
			char ch = s.charAt(i);
			System.out.println(ch);
		}
	}
}
```


## 统计字符串中大写, 小写, 数字字符的个数

* 统计大写字母: `char >= 'A' && char <= 'Z'`
* 统计小写字母: `char >= 'a' && char <= 'z'`
* 统计数字字符: `char >= '0' && char <= '9'`


* 5分钟练习:
	* 继续使用项目s1-day08, 建包com.itheima.practice_04, 建类Test
	* 定义3个变量: bigNum, smallNum, numNum, 分别用于存储大写, 小写, 数字字符个数
	* 键盘录入一个字符串
	* 使用for循环遍历
		* 获取字符串的每个字符
		* 判断该字符属于哪个范围, 并计数
	* 最后打印个数

```java
/*
键盘录入一个字符串
分别统计大写,小写及数字字符的个数
打印出大写字符个数,小写字符个数和数字字符个数
 */
public class Test {

	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);
		System.out.println("请输入一个字符串:");
		String s = scanner.nextLine();
		
		// 定义计数器变量
		int bigCount = 0;
		int smallCount = 0;
		int numberCount = 0;
		
		// 遍历字符串
		for (int i = 0; i < s.length(); i++) {
			// 获取字符
			char ch = s.charAt(i);
			// 判断
			if (ch >= 'A' && ch <= 'Z') {
				bigCount++;
			} else if (ch >= 'a' && ch <= 'z') {
				smallCount++;
			} else if (ch >= '0' && ch <= '9') {
				numberCount++;
			} else {
				System.out.println("该字符" + ch + "非法");
			}
		}
		// 打印结果
		System.out.println("大写字符:" + bigCount);
		System.out.println("小写字符:" + smallCount);
		System.out.println("数字字符:" + numberCount);
	}
}
```



## String类的转换功能

* 转换功能
    * `char[] toCharArray()`: 将字符串转换为字符数组
    * `String toLowerCase()`: 将字符串转换为小写字符串  String s = "HELLO".toLowerCase();   // "hello"
    * `String toUpperCase()`: 将字符串转换为大写字符串


## 把字符串首字母大写, 其他字母小写


* 分析:
    * 获取第一个字母: `String substring(0, 1)`: 返回截取后的子字符串
    * 获取剩余字母: `String substring(1)`: 从索引1截取到末尾
    * 转大写: `String toUpperCase()`: 返回转为大写的新字符串
    * 转小写: `String toLowerCase()`: 返回转为小写的新字符串


* 5分钟练习: 首字母大写
	* 继续使用项目s1-day08, 建包com.itheima.practice_05, 建类Test
	* 键盘录入一个字符串
	* 使用`substring(from, to)`方法获取字符串的第一个字符, 将其转换为大写
	* 使用`substring(from)`方法获取字符串的其他部分, 将其转换为小写
	* 打印最终拼接的字符串

```java
/*
键盘录入一个字符串
将该字符串的首字母变成大写
将该字符串的其它字母全部转换为小写
打印最终的字符串
 */
public class Test {

	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);
		System.out.println("请输入一个字符串:");
		String s = scanner.nextLine();
		
		// 获取首字母
		String first = s.substring(0, 1);
		// 获取其他字母
		String other = s.substring(1);
		
		// 将首字母转大写, 其他字母转小写, 拼接结果
		String result = first.toUpperCase() + other.toLowerCase();
		
		// 打印
		System.out.println(result);
	}
}
```


## String类的去空格和分割方法

```java
// 去空格
"  dfdfdf     dfdfdf    ".trim();         // "dfdfdf     dfdfdf"

// 分割
String[] arr = "2018/03/21".split("/");   // {"2018", "03", "21"}
```

* `String trim()`: 去除字符串**两端**的**半角空白字符**(空格, 制表符, 换行等), 中间的空白字符无法去掉. 返回去掉两端空白字符的字符串 
* `String[] split(String regex)`: 以指定正则表达式将字符串分割为多个部分, 保存在字符串数组中. 最终数组中不会包含作为分隔符的正则表达式 
* 扩展:
	* `String replaceFirst(String regex, String replacement)`: 将该对象中匹配regex正则的第一个出现的字符串替换为replacement, 并返回替换后的字符串

例如:
```java
// 将"hello world, Good world"中的world替换为java, 可以写为
String s = "hello world, Good world".replaceFirst("world", "java");  
System.out.println(s);  // "hello java, Good world"


// 想删掉`hello world, Good world`中的第一个world, 可以写为
String s = "hello world, Good world".replaceFirst("world", "");
System.out.println(s);  // "hello , Good world"
```



---




## 练习: 数组元素按格式拼接

```java
// {1,2,3}打印成[1, 2, 3] 怎么实现?
public static void print(int[] arr) {
    
}
```

* 5分钟练习: 将数组打印为指定格式字符串
	* 继续使用项目s1-day08, 建包com.itheima.practice_06, 建类Test
	* 定义一个方法将数组转换为字符串的美化形式
		* 每个部分使用字符串拼接
		* 最终返回拼接后的字符串
	* main方法中定义一个数组, 调用方法获取字符串并打印

```java
/*
已知 int[] arr={1,2,3,4}
定义一个方法
该方法返回数组中元素的拼接
格式为[1, 2, 3, 4]
 */
public class Test {

	public static void main(String[] args) {
		int[] arr={1,2,3,4};
		String result = arrayToString(arr);
		System.out.println(result);
	}
	
	// 将数组转换为字符串
	public static String arrayToString(int[] arr) {
		// 定义字符串, 先保存左中括号
		String s = "[";
		// 遍历元素
		for (int i = 0; i < arr.length; i++) {
			if (i == arr.length - 1) {
				// 拼接最后一个元素
				s += arr[i];
			} else {
				// 拼接元素和逗号空格
				s += arr[i];
				s += ", ";
			}
		}
		// 循环结束后拼接右中括号
		s += "]";
		// 返回结果
		return s;
	}
}
```


## 练习: 字符串反转

```
"abc" -> "cba"

1. "abc" -> char[]  首尾元素交换 -> char[] -> new String(chs)
2. "abc"  
```

* 怎么反转? 
	* 方式1: 倒序遍历字符拼接字符串
	* 方式2: 转字符数组首尾交换再转为字符串


* 5分钟练习: 反转键盘录入的字符串
	* 继续使用项目s1-day08, 建包com.itheima.practice_07, 建类Test
	* 键盘录入一个字符
	* 定义2个方法reverse将字符串反转并返回
	* 打印字符串

```java
/*
键盘录入一个字符串
输出反转后的新的字符串
 */
public class Test {

	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);
		System.out.println("请输入一个字符串:");
		String s = scanner.nextLine();
		
		System.out.println(reverse(s));
		System.out.println(reverse2(s));
	}
	
	// 反转字符串: 转为char[]首尾元素交换
	public static String reverse2(String s) {
		// 转为字符数组
		char[] chs = s.toCharArray();
		// 遍历元素首尾交换
		for (int start = 0, end = chs.length - 1; start < end; start++, end--) {
			// 交换元素
			char temp = chs[start];
			chs[start] = chs[end];
			chs[end] = temp;
		}
		// 将交换后的数组转换为String
		return new String(chs);
	}
	
	// 反转字符串: 倒序遍历字符拼接
	public static String reverse(String s) {
		String result = "";
		// 倒序遍历
		for (int i = s.length() - 1; i >= 0; i--) {
			// 获取字符并拼接
			result += s.charAt(i);
		}
		// 返回字符串
		return result;
	}
}
```






## StringBuilder

* StringBuilder作用
	* 高效拼接字符串
* 加号拼接和StringBuilder的区别
	* `+`加号拼接字符串效率低 
		* JVM在每次使用`+`拼接字符串时, 默认会转换为创建一个新的`StringBuilder`对象调用`append()`方法来拼接, 既耗时, 又浪费内存空间
	* StringBuilder拼接效率高
		* StringBuilder是一个可变字符序列, 有一个字符串缓冲区, 如果字符超出范围, 则会自动扩容
		* 使用StringBuilder的`append()`方法拼接, 全程只有一个StringBuilder对象, 不会浪费额外的内存空间


* 示例

```java
String result = "a" + "b" + "c" + "d";  // +号拼接3次, 相当于创建了3个StringBuilder对象
// "a" + "b":   相当于new StringBuilder("a").append("b").toString(), 结果为"ab";
// "ab" + "c":  相当于new StringBuilder("ab").append("c").toString(), 结果为"abc";
// "abc" + "d": 相当于new StringBuilder("abc").append("d").toString(), 结果为"abcd";


StringBuilder sb = new StringBuilder(); 
sb.append("a")      
	.append("b")    
	.append("c")    
	.append("d");   
String result1 = sb.toString();  // 使用的都是同一个StringBuilder对象
```


## StringBuilder构造方法

* 构造方法
    * `StringBuilder()`: 默认容量16个字符
* 成员方法
	* `int capacity()`: 返回当前StringBuilder的容量
    * `int length()`: 返回当前StringBuilder中保存的字符数


## StringBuilder的追加功能和反转功能

* 追加字符串: 
  * `StringBuilder append(任意类型)`:  追加内容到当前字符串的尾部   sb.append("1")   "abc1"
    * 可以连续调用(链式调用)   sb.append("").append("").append().reverse().append()
* 反转字符串: 
  * `StringBuilder reverse()`: 反转当前StringBuilder中保存的字符串内容



---





## StringBuilder和String相互转换

* 转换
    * StringBuilder -> String: 
        * 通过StringBuilder对象的`toString()`方法: `String str = stringBuilder.toString()`
    * String -> StringBuilder: 
        * 通过StringBuilder类的构造方法:  `StringBuilder sb = new StringBuilder(str);`


* 3分钟练习: 测试StringBuilder转为String
	* 继续使用项目s1-day08, 建包com.itheima.practice_08, 建类Test
	* 定义一个StringBuilder
		* StringBuilder初始化的时候就有字符串”hello”
		* 向StringBuilder中追加 ”1”,20,true
		* 将StringBuilder中的数据做为一个字符串返回

```java
/*
定义一个StringBuilder
StringBuilder初始化的时候就有字符串”hello”
向StringBuilder中追加 ”1”,20,true
将StringBuilder中的数据做为一个字符串返回
 */
public class Test {

	public static void main(String[] args) {
		// StringBuilder初始化的时候就有字符串”hello”
		StringBuilder sb = new StringBuilder("hello");
		// 向StringBuilder中追加 ”1”,20,true
		sb.append("1")
			.append(20)
			.append(true);
		// 将StringBuilder中的数据做为一个字符串返回
		String s = sb.toString();
		
		System.out.println(s);  // hello120true
	}
}
```



## 练习: 数组元素按格式拼接

* 5分钟练习: 数组元素按格式拼接打印
	* 继续使用项目s1-day08, 建包com.itheima.practice_09, 建类Test
	* 定义方法arrayToString
		* 使用StringBuilder实现数组转换为字符串并返回
	* main方法定义数组测试

```java
/*
利用StringBuilder把数组拼接成一个字符串
举例:int[ ] arr={1,2,3}
结果:[1, 2, 3]
 */
public class Test {

	public static void main(String[] args) {
		int[] arr={1,2,3};
		String result = arrayToString(arr);
		System.out.println(result);
	}
	
	// 数组转字符串
	public static String arrayToString(int[] arr) {
		// 创建StringBuilder
		StringBuilder sb = new StringBuilder();
		// 拼接左中括号
		sb.append("[");
		// 遍历元素
		for (int i = 0; i < arr.length; i++) {
			if (i == arr.length - 1) {
				sb.append(arr[i]);
			} else {
				sb.append(arr[i]).append(", ");
			}
		}
		// 最后拼接右中括号
		sb.append("]");
		// 返回字符串形式
		return sb.toString();
	}
}
```


## StringBuilder字符串反转

* 反转String: 
	* 利用StringBuilder的方法实现: `String -> StringBuilder -> reverse() -> toString()`


```java
String str = "hello";
StringBuilder sb = new StringBuilder(str);
sb.reverse();
String reverseStr = sb.toString();
// olleh


"abc"  "cba"
```


## 练习: 判断对称字符串

* 怎么判断字符串对称(回文)? 
	* 反转过来是一样的, 就是回文


* 5分钟练习: 判断对称字符串
	* 继续使用项目s1-day08, 建包com.itheima.practice_10, 建类Test
	* 定义方法isSymmetical判断字符串是否为回文
		* 调用StringBuilder的reverse()方法将原字符串转换为反转的字符串
		* 调用equals方法比较字符串是否内容一样
	* main方法中键盘录入字符串, 打印测试结果

```java
/*
利用StringBuilder完成以下需求
判断一个字符串是否是对称字符串
 例如"abc"不是对称字符串，"aba"、"abba"、"aaa"、"mnanm"是对称字符串
 */
public class Test {

	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);
		System.out.println("请输入要反转的字符串:");
		String s = scanner.nextLine();
		
		System.out.println(reverse(s));
	}
	
	// 判断是否是对称字符串
	public static boolean isDuichen(String s) {
		// 将String转换为StringBuilder
		StringBuilder sb = new StringBuilder(s);
		// 反转内容
		sb.reverse();
		// 将反转后的sb转换为String
		String reversedString = sb.toString();
		// 比较是否相同并返回
		return s.equals(reversedString);
	}
}
```



-------------------------------------


## 今日扩展


* 定义方法时, static有什么作用?
	* static表示静态, 静态的详细内容在就业班基础进阶第一天会讲解
	* static的方法中只能调用static的方法


* String, StringBuilder和StringBuffer的区别
	* String代表字符串常量, 字符串内容是不可变化的
	* StringBuilder和StringBuffer是字符串变量, 其中包含的字符串内容是可以变化的
	* StringBuilder从JDK1.5出现, 线程不安全, 操作字符串效率高
	* StringBuffer从JDK1.0出现, 线程安全, 操作字符串效率低
	* 正因为String字符串是不可变的, 所以String对象调用修改字符串的方法后本身并没有变化, 而是返回变化后的新字符串对象; 而StringBuilder可变, 所以调用方法后自身就是改变之后的字符串


* 链式编程的实现
	* 在成员方法中返回this

```java
/*
 * 定义一个猫类
 * 将用于链式调用的方法都返回当前类的对象this
 */
public class Cat {

	public Cat eat() {
		System.out.println("吃");
		return this;
	}

	public Cat drink() {
		System.out.println("喝");
		return this;
	}

	public Cat sleep() {
		System.out.println("睡");
		return this;
	}
}

// 调用示例
Cat cat = new Cat();
cat.eat().drink().sleep();  // 链式调用
```


* 怎么使用API文档?
    * chm离线文档
    * IDE中的文档提示
    * http://tool.oschina.net/



## 今日总结

* API  Application Programming Interface
  * 概念: 应用程序编程接口. (Java提供的已经定义好的一些类和方法)
  * API文档
    * 类似于说明书
    * 找到合适的类, 找到合适的方法, 直接写代码





* Scanner类
  * `String nextLine()`: 获取键盘录入的字符串
* String类
  * 构造方法
  	* `String(String)`: 使用一个字符串创建一个String对象
  	* `String(char[] value)`: 通过char数组创建一个String对象
  	* `String(char[] value, int offset, int count)`: 使用char数组中从offset索引开始, 取count个字符来创建一个字符串对象
  * 成员方法
  	* 判断功能
  		* `boolean equals(Object anObject)`: 比较字符串的内容是否相同, 区分大小写
  		* `boolean equalsIgnoreCase(String anotherString)`: 比较字符串的内容是否相同, 不区分大小写
  		* `boolean startsWith(String prefix)`: 是否以指定的字符串开头
  		* `boolean endsWith(String suffix)`: 是否以指定的字符串结尾
  		* `boolean contains(CharSequence s)`: 是否包含指定的字符串
  	* 获取功能
  		* `int length()`: 获取字符串的长度
  		* `char charAt(int index)`: 获取指定索引处的字符
  		* `int indexOf(String str)`: 获取str在字符串对象中第一次出现的索引, 没有则返回-1
  		* `String substring(int beginIndex)`: 从beginIndex索引开始截取字符串, 到字符串的末尾
  		* `String substring(int beginIndex, int endIndex)`: 从beginIndex开始截取字符串, 到endIndex结束, 不包括endIndex
  	* 转换功能
  		* `char[] toCharArray()`: 将字符串转换为字符数组
  		* `String toLowerCase()`: 将字符串转换为小写字符串
  		* `String toUpperCase()`: 将字符串转换为大写字符串
  	* 其他功能
  		* `String trim()`: 去除字符串两端的半角空白字符(空格, 制表符, 换行等), 中间的空白字符无法去掉. 返回去掉两端空白字符的字符串
  		* `String[] split(String regex)`: 以指定正则表达式将字符串分割为多个部分, 保存在字符串数组中. 最终数组中不会包含作为分隔符的正则表达式
  		* `String replaceFirst(String regex, String replacement)`: 将该对象中匹配regex正则的第一个出现的字符串替换为replacement, 并返回替换后的字符串
  * String类的`==`和`equals()`的区别
  	* `==`的作用
  		* 对于基本数据类型: 比较基本数据类型的值
  		* 对于引用数据类型: 比较引用数据类型的地址值
  	* `equals()`: 比较字符串的内容是否相同, 而不是比较地址值
  * 字符串的内存注意事项
  	* 创建一个String对象的2种方式:
  		* 构造方法: `String()`
  		* 使用字符串常量: `"hello"`
  	* 对象创建在哪
  		* 构造方法是在堆内存中创建一个对象, 然后该对象保存的是字符串在常量池中的地址值
  			* `String s = new String("Hello");`
  				* 首先创建了常量池中的`"Hello"`对象
  				* 然后创建了堆内存中的`new String()`对象
  				* `new String()`对象保存常量池中字符串的地址
  				* 变量s保存堆内存中`new String()`的地址
  		* 字符串常量是在方法区的常量池中创建的对象, 有一个地址值. 该字符串不可变, 创建一次可以重复使用
  			* `String s = "hello";`
  				* 首先创建了常量池中的`"hello"`对象
  				* 然后将常量池中对象的地址值赋值给变量s
* StringBuilder
  * 作用: 高效的拼接字符串
  * `StringBuilder`: 用于高效拼接字符串的类
  	* 构造方法:
  		* `StringBuilder()`: 创建一个StringBuilder对象
  		* `StringBuilder(String str)`: 使用一个String创建一个StringBuilder对象. 用于将String转换为StringBuilder
  	* 成员方法:
  		* `int capacity()`: 返回当前StringBuilder的容量
    		* `int length()`: 返回当前StringBuilder中保存的字符数
  		* `StringBuilder reverse()`: 反转当前StringBuilder中保存的字符串内容
  		* `StringBuilder append(任意类型)`: 追加内容到当前字符串的尾部
  		* `String toString()`: 将StringBuilder对象转换为String
![image](https://note.youdao.com/favicon.ico)

<html>
<!--重点String使用-->
</html>

