## 今日总结

* 包
	* 就是目录
	* 作用: 分类管理Java文件, 避免重名类的冲突
	* 特点: 包可以有多个层级
	* 定义包:
		* 关键字: `package`
		* 格式: `pacakge 包名;`
			* 多级目录用`.`区分
		* 要求: 包的声明必须在文件第一行
	* 类的全名: `包名.类名`
	* 包的访问规则:
		* 相同包下的类, 直接访问
		* 不同包下的类, 可以导包或使用类的全名
	* 导包:
		* 本质上导入的是包中的类
		* 关键字: `import`
		* 格式: 
			* 导入具体的一个类: `import 包名.类名;`
			* 导入包中所有类: `import 包名.*;`
		* 定义位置: 包声明的下方, 类声明的上方
* 权限修饰符
	* 4种权限修饰符
		* private: 私有的, 仅在本类中可见
		* 默认: 在同一个包中可见
		* protected: 受保护的, 同一个包中, 或者子类中可见
		* public: 项目中都可见
	* 权限修饰符能够修饰的元素(见下表)
* 内部类
	* 概念: 定义在类中的类
	* 分类:
		* 成员内部类
			* 非静态成员内部类
				* 创建内部类的格式: `外部类名.内部类名 对象名 = new 外部类名().new 内部类名();`
				* 导入内部类: `import 包名.外部类名.内部类名;`
			* 静态成员内部类
				* 创建内部类的格式: `外部类名.内部类名 对象名 = new 外部类名.内部类名();`
		* 局部内部类
			* 定义位置: 定义在方法中
			* 如何使用: 调用方法, 才会出现类的定义, 然后创建对象, 调用方法
			* 注意: 类随着方法的调用而定义, 随着方法的调用完毕而消失
			* 用的非常非常少
		* 匿名内部类
			* 定义位置: 方法中或方法形参上
			* 格式: (见下方)
			* 注意:
				* new出来的本质上是父类或父接口的实现类, 该实现类没有名字
				* 如果创建的是继承普通类的匿名内部类对象, 则可以选择重写父类方法
				* 如果创建的是继承抽象类或实现接口的匿名内部类对象, 则必须重写方法
			* 应用场景:
				* 作为方法的参数传递
				* 作为只使用一次的对象, 避免定义一个类
				

```java
// 匿名内部类的格式
new 父类或父接口() {
	// 可能需要重写方法
};

// 匿名内部类直接调用方法
new 父类或父接口() {
	// 重写方法
}.方法名();

// 创建对象并赋值
父类或接口 对象名 = new 父类或父接口() {
	// 重写方法
};
```

* 权限修饰符可以修饰的元素

|修饰符    |  类    |成员变量|成员方法|构造方法|
|---------|--------|-------|-------|-------|
|public   |   √    |   √   |   √   |   √   |
|默认     |   √    |   √   |   √   |   √   |
|protected|   ×    |   √   |   √   |   √   |
|private  |   ×    |   √   |   √   |   √   |
|abstract |   √    |   ×   |   √   |   ×   |
|static   |   ×    |   √   |   √   |   ×   |
|final    |   √    |   √   |   √   |   ×   |