## 今日总结

* 静态
  * 关键字: `static`
  * 作用: 修饰变量, 方法, 类, 被其修饰的成员被所有对象共享
  * 调用静态成员:
  	* 调用静态成员变量: `类名.静态成员变量`, `Math.PI`
  	* 调用静态成员方法: `类名.静态成员方法()`, `Math.pow(2,3)`
  * 特点
  	* 静态成员被所有对象共享
  	* 可以直接使用类名调用
  	* 静态成员的加载优先于非静态的成员
  	* 静态成员的生命周期跟随类的加载而加载, 随着程序的结束而销毁
  * 静态成员变量保存在: 
    * 内存中方法区中该类的字节码对象中的静态区域中
  * 静态成员和非静态成员的区别
  	* 生命周期不同
  		* 静态成员: 跟随类的加载而创建, 随着程序的结束而销毁
  		* 非静态成员: 跟随对象的创建而创建, 跟随对象的销毁而销毁 
  	* 内存中的位置不同
  		* 静态成员: 方法区中类的字节码对象中的静态区域中
  		* 非静态成员: 堆内存中对象区域中
  	* 初始化时机不同
  		* 静态成员: 类加载时初始化
  		* 非静态成员: 创建对象时初始化
  * 静态方法的调用注意事项
  	* 非静态方法中, 可以调用静态和非静态的成员
  	* 静态方法中, 只能调用静态的成员
  * 静态方法中能够使用this? 
    * 不能, 因为静态和非静态的生命周期不同. 静态方法跟随类加载而加载, 此时不一定有对象, 所以没有this
  * 静态的优缺点:
  	* 优点:
  		* 共享数据保存在同一个存储空间中, 节省内存
  		* 可以直接类名调用, 简化代码编写
  	* 缺点:
  		* 访问有限制, 静态方法中只能访问静态成员
  * 应用场景:
  	* 作为该类所有对象共享的数据
  	* 工具类
  		* 把构造方法私有
  		* 所有方法用static修饰, 类名直接调用
* 代码块
	* 概念: `{}`大括号括起来的就是代码块
	* 分类:
		* 静态代码块
			* 定义位置: 类中, 方法外, 前面要加static
			* 执行时机: 类加载时执行
			* 执行次数: 只有一次
			* 作用: 在类加载时进行一些初始化操作
		* 构造代码块
			* 定义位置: 类中, 方法外
			* 执行时机: 每次创建对象时执行, 优先于构造方法执行
			* 执行次数: 创建多少次对象, 就执行多少次
			* 作用: 抽取构造方法共同执行的代码, 简化书写
		* 局部代码块
			* 定义位置: 方法中
			* 执行时机: 调用方法时, 执行到局部代码块则执行
			* 执行次数: 调用多少次方法能够执行到, 就执行多少次
			* 作用: 限制局部变量的作用域
		* 同步代码块(多线程讲)
* Math类
	* 静态成员属性: 
		* `static double PI`: 接近圆周率的一个double数字, 3.1415...
	* 静态成员方法: 
		* `static int/long/float/double abs(int/long/float/double a)`: 返回一个数字的绝对值
		* `static double ceil(double a)`: 向上取整
		* `static double floor(double a)`: 向下取整
		* `static long round(double a)`: 四舍五入
		* `static int round(float a)`: 四舍五入
		* `static int/long/float/double max(int/long/float/double a, int/long/float/double b)`: 返回两者较大值
		* `static int/long/float/double min(int/long/float/double a, int/long/float/double b)`: 返回两者较小值
		* `static double pow(double a, double b)`: 返回第一个参数的第二个参数次幂
		* `static double random()`: 返回一个大于等于0.0并小于1.0的随机数