## 基础语法练习

### 练习: 根据月份输出对应季节

* 6分钟练习: 根据输入月份打印对应季节
	* 继续使用s1-day06项目, 建包com.itheima.practice_05, 建类Test
	* 创建Scanner对象获取录入的月份
	* 利用switch判断月份:
		* 不利用case穿透
		* 利用case穿透
	- 异常情况处理
		- 非法数据default

```java
/*
独立用switch完成根据月份输出对应季节
 */
public class Test {

	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);
		System.out.println("请输入月份(1-12):");
		int month = scanner.nextInt();
		
		// 使用switch
		switch (month) {
		case 12:
		case 1:
		case 2:
			System.out.println("冬季");
			break;
		case 3:
		case 4:
		case 5:
			System.out.println("春季");
			break;
		case 6:
		case 7:
		case 8:
			System.out.println("夏季");
			break;
		case 9:
		case 10:
		case 11:
			System.out.println("秋季");
			break;
		default:
			System.out.println("您输入的月份有误!");
			break;
		}
	}
}
```


### 练习: 打印回文数

* 回文数
	- 12321, 123321
* 分析
	- for循环
	- 个位, 十位, 百位等数字的计算
		- `/`
		- `%`


* 6分钟练习: 打印5位数的回文数
	* 继续使用s1-day06项目, 建包com.itheima.practice_06, 建类Test
	* for循环获取五位数的每一位
	* if判断是否为回文(wan == ge && qian == shi), 是则打印

```java
/*
独立完成打印五位数中所有回文数的案例
 */
public class Test {

	public static void main(String[] args) {
		// for循环产生五位数
		for (int i = 10000; i < 100000; i++) {
			// 获取个位十位千位万位
			int ge = i % 10;
			int shi = i / 10 % 10;
			int qian = i / 1000 % 10;
			int wan = i / 10000 % 10;
			// 判断是否符合规律
			if ((ge == wan) && (shi == qian)) {
				System.out.println(i);
			}
		}
	}
}
```





---=






### 练习: 不死神兔



```
规律: n月的兔子总数 = n-1月的兔子总数 + n-2月的兔子总数

int three = 1 +1  
int four = three + two;
int ...
...

[1,1,2,_,_,....]  20月
new int[20];

 0 1 2
 arr[2] = arr[1] + arr[0];
 arr[3] = arr[2] + arr[1];
 arr[4] = arr[3] + arr[2];
 ..
 arr[19] = arr[18] + arr[17];

arr[0] = 1;
arr[1] = 1;
for (int x = 2; x < arr.length; x++) {
    arr[x] = arr[x - 1] + arr[x - 2];
}
arr[19]
```


* 斐波那契数列  fibonacci
    * 生兔子: 一对兔子从第3个月起, 每个月都生1对兔子, 小兔子也这样, 请问第20月总共有多少兔子?
* 分析
	- 查看规律
	- 利用数组存储1-20月每月兔子数
	- 先将1,2月的兔子数填入
	- 利用for循环推算后续月份的兔子数


* 6分钟练习: 定义方法, 形参接收月份, 计算兔子总数
	* 继续使用s1-day06项目, 建包com.itheima.practice_07, 建类Test
	* 定义方法生产兔子:
		* 方法修饰符: public static
		* 返回值类型: `int[]`
		* 方法名: produceRabbit
		* 参数列表: int month
		* 方法体:
			* 根据month创建数组
			* 前两个月都是1个兔子
			* 从第三个月开始: `arr[i] = arr[i - 1] + arr[i - 2];`
			* 最后返回数组
	* 在main方法中测试方法

```java
/*
定义一个单独的方法
方法形参接收月份
方法功能求出该月的兔子对数
方法返回值返回求得的兔子对数
测试该方法
 */
public class Test {

	public static void main(String[] args) {
		System.out.println(calcRabbit(20));  // 6765
	}
	
	// 求第month个月的兔子总对数
	public static int calcRabbit(int month) {
		// 根据月份创建一个数组, 用于存储每个月的兔子总对数
		int[] arr = new int[month];
		// 先把前两个月的兔子对数存储
		arr[0] = 1;
		arr[1] = 1;
		// 其余月份按照规律推算
		for (int i = 2; i < arr.length; i++) {
			// 第i月的兔子对数 = 第i-1月的兔子对数 + 第i-2月的兔子对数
			arr[i] = arr[i - 1] + arr[i - 2];
		}
		// 返回指定月份的兔子总数
		return arr[month - 1];
	}
}
```

### 练习: 满足要求的数组元素和

* 5分钟练习:
	* 继续使用s1-day06项目, 建包com.itheima.practice_08, 建类Test
	* 一维数组
	* 求和变量
	* 遍历数组, 判断元素是否满足条件, 满足则累加

```java
/*
编写对满足要求的额数组元素进行求和案例的代码
要求:
Int[] arr = {171,72,19,16,118,51,210,7,18};
个位不能是7
十位不能是7
必须是偶数
 */
public class Test {

	public static void main(String[] args) {
		// 定义数组
		int[] arr = {171,72,19,16,118,51,210,7,18};
		// 定义求和变量
		int sum = 0;
		// 遍历数组
		for (int i = 0; i < arr.length; i++) {
			// 判断该元素是否满足要求
			if ((arr[i] % 10 != 7) && (arr[i] / 10 % 10 != 7) && (arr[i] % 2 == 0)) {
				// 累加
				sum += arr[i];
			}
		}
		// 打印总和
		System.out.println(sum);
	}
}
```



---






### 练习: 评委打分

* 要求: 去掉最高分, 最低分, 求平均分
* 分析
	- 定义长度为评委数量的数组
	- Scanner获取录入, 计入数组
	- 获取数组的最大值, 最小值
		- 定义参照物
	- 获取数组元素和
	- 平均分 = (元素和 - 最高分 - 最低分) / (数组长度 - 2)

* 6分钟练习: 评委打分
	* 继续使用s1-day06项目, 建包com.itheima.practice_09, 建类Test

```java
/*
编写评委打分案例的代码
先定义一个数组(存储6个评委的分数)
键盘录入每个分数
公式: (所有分数的总和-最高分-最低分)/(数组长度-2)
定义方法获取最高分, 最低分, 总和
 */
public class Test {

	public static void main(String[] args) {
		// 定义一个数组存储评委分数
		int[] arr = new int[6];
		// 创建键盘录入
		Scanner scanner = new Scanner(System.in);
		// 循环
		for (int i = 0; i < arr.length; i++) {
			// 提示
			System.out.println("请输入第" + (i + 1) + "名评委的分数(0-100):");
			// 存入数组
			arr[i] = scanner.nextInt();
		}
		
		// 调用方法获取最高分
		int max = getMax(arr);
		// 调用方法获取最低分
		int min = getMin(arr);
		// 调用方法获取总分
		int sum = sum(arr);
		// 计算平均分
		int avg = (sum - max - min) / (arr.length - 2);
		
		System.out.println("该选手的最终得分为:" + avg);
	}
	
	// 获取数组最大值
	public static int getMax(int[] arr) {
		int max = arr[0];
		for (int i = 1; i < arr.length; i++) {
			if (arr[i] > max) {
				max = arr[i];
			}
		}
		return max;
	}
	
	// 获取数组最大值
	public static int getMin(int[] arr) {
		int min = arr[0];
		for (int i = 1; i < arr.length; i++) {
			if (arr[i] < min) {
				min = arr[i];
			}
		}
		return min;
	}
	
	// 数组求和
	public static int sum(int[] arr) {
		int sum = 0;
		for (int i = 0; i < arr.length; i++) {
			sum += arr[i];
		}
		return sum;
	}
}

```




### 练习: 数组元素反转

```
{1,2,3,4,5}
     |
{5,4,3,2,1}

如何操作?
	首尾元素交换 
	变量交换值:
		定义一个第三方变量(临时)
	何时重复何时停止?

{5,4,3,2,1}  
int temp = arr[0];
arr[0] = arr[4];
arr[4] = temp;

int temp = arr[1];
arr[1] = arr[3];
arr[3] = temp;
```






* 反转: reverse
* 分析
	- 定义数组
	- Scanner输入数组元素
	- 实现反转
		- 首尾元素交换
			- 开头索引++, 结尾索引--
			- 引入第三方变量交换
		- 注意界限
		

* 7分钟练习: 
	* 继续使用s1-day06项目, 建包com.itheima.practice_10, 建类Test
	* 定义方法`reverse(int[] arr)`, for循环定义两个变量i, j, 首尾元素交换

```java
/*
定义一个长度为5的数组
利用键盘录入为数组中的元素赋值
循环遍历打印数组
反转数组
打印反转后的数组
 */
public class Test {

	public static void main(String[] args) {
		// 定义数组
		int[] arr = new int[5];
		// 创建键盘录入
		Scanner scanner = new Scanner(System.in);
		// 循环录入
		for (int i = 0; i < arr.length; i++) {
			// 提示
			System.out.println("请输入第" + (i + 1) + "个数值:");
			arr[i] = scanner.nextInt();
		}
		
		// 打印反转前的数组
		print(arr);
		// 反转数组
		reverse(arr);
		// 打印反转后的数组
		print(arr);
	}
	
	// 定义方法反转数组
	public static void reverse(int[] arr) {
		// for循环定义2个索引, 开始索引递增, 结束索引递减
		for (int start = 0, end = arr.length - 1; start <= end; start++, end--) {
			// 交换开始索引和结束索引上的元素
			int temp = arr[start];
			arr[start] = arr[end];
			arr[end] = temp;
		}
	}
	
	// 定义方法打印数组
	public static void print(int[] arr) {
		System.out.print("[");
		for (int i = 0; i < arr.length; i++) {
			if (i == arr.length - 1) {
				System.out.println(arr[i] + "]");
			} else {
				System.out.print(arr[i] + ", ");
			}
		}
	}
}
```





---




​		

### 练习: 数组基本查找


```
{1,2,3,3,3,34,5}   0 - 大于0
4索引: 3

20索引: -1(表示没有该元素)

参数列表: int[] arr, int value
返回值类型: int  
找元素第一次出现的索引位置
for (int i = 0; i < arr.length; i++) {
	if (arr[i] == value) {
		// 说明找到了
		return i;
	}
}
// 找不到
return -1;
```


* 查找元素第一次出现的索引
* 分析
	- Scanner录入数组数据
	- 实现查找方法
		- 遍历数组, 依次比较元素, 如果相等, 就把该处索引返回
	- 异常情况处理
		- 查不到返回-1


* 5分钟练习: 查找数组元素的索引
	* 继续使用s1-day06项目, 建包com.itheima.practice_11, 建类Test
	* 定义方法, for循环遍历, 判断如果相等则返回索引, 找不到则返回-1

```java
/*
练习数组基本查找案例
单独定义一个getIndex方法
方法接收数组和要查找的元素
方法返回找到的元素索引,没找到返回-1
测试该方法
 */
public class Test {

	public static void main(String[] args) {
		// 定义数组
		int[] arr = {1,5,3,4,5};
		
		System.out.println(getIndex(arr, 5));
		System.out.println(getLastIndex(arr, 5));
		
	}
	
	// 查找指定值在数组中第一次出现的索引
	public static int getIndex(int[] arr, int value) {
		// 遍历元素比较
		for (int i = 0; i < arr.length; i++) {
			// 比较是否相等
			if (arr[i] == value) {
				// 返回索引
				return i;
			}
		}
		// 如果能执行到这里, 说明上面for循环没有执行return, 也就是说没有找到任何相同的值, 说明数组中没有该值. 返回一个不存在的索引表示找不到
		return -1;
	}
	
	// 查找指定值在数组中最后一次出现的索引
	public static int getLastIndex(int[] arr, int value) {
		// 遍历元素比较
		for (int i = arr.length - 1; i >= 0; i--) {
			// 比较是否相等
			if (arr[i] == value) {
				// 返回索引
				return i;
			}
		}
		// 如果能执行到这里, 说明上面for循环没有执行return, 也就是说没有找到任何相同的值, 说明数组中没有该值. 返回一个不存在的索引表示找不到
		return -1;
	}
	
	// 判断数组中是否包含指定的值(true/false)
	public static boolean contains(int[] arr, int value) {
		for (int i = 0; i < arr.length; i++) {
			if (arr[i] == value) {
				// 说明包含
				return true;
			}
		}
		// 说明不包含
		return false;
	}
}
```


### 练习: 数据加密


* 分析
	- 将录入密码存入数组
	- 进行加密处理
    	- 每位数字都加上5, 然后除以10的余数, 来替代该数字
        - 再将第一位和第四位交换, 第二位和第三位交换


* 6分钟练习: 数据加密
	* 继续使用s1-day06项目, 建包com.itheima.practice_12, 建类Test
	* 将四位整数每位上的数字存储到一个数组中
		* 获取各个位
	* 修改数字
		* 每位数字都加上5, 然后除以10的余数, 来替代该数字
		* 再将第一位和第四位交换, 第二位和第三位交换

```java
/*
完成对四位整数进行加密的代码
求出四位整数每位上的数字
将四位整数每位上的数字存储到一个数组中
按照要求改变数组中元素的值
每位数字都加上5, 然后除以10的余数, 来替代该数字
再将第一位和第四位交换, 第二位和第三位交换
最终打印加密后的四位数
 */
public class Test {

	public static void main(String[] args) {
		// 键盘录入
		Scanner scanner = new Scanner(System.in);
		System.out.println("请输入一个4位数字:");
		int number = scanner.nextInt();
		// 创建数组
		int[] arr = new int[4];
		// 获取每个位的值
		arr[3] = number % 10;
		arr[2] = number / 10 % 10;
		arr[1] = number / 100 % 10;
		arr[0] = number / 1000 % 10;
		// 循环改变所有值
		for (int i = 0; i < arr.length; i++) {
			// 每位数字都加上5
			arr[i] += 5;
			// 然后除以10的余数
			arr[i] %= 10;
		}
		// 再将第一位和第四位交换
		int temp = arr[0];
		arr[0] = arr[3];
		arr[3] = temp;
		// 第二位和第三位交换
		temp = arr[1];
		arr[1] = arr[2];
		arr[2] = temp;
		// 遍历打印
		for (int i = 0; i < arr.length; i++) {
			System.out.print(arr[i]);
		}
	}
}
```

-----------------------------


## 今日重点

* 数组
	* 元素反转
	* 查找元素的索引
